/*
 * Teaser - an ICQ like server for the client `firecat'.
 * Copyright (C) 1998 Matthew Parry <mettw@bowerbird.com.au>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <teaser.h>

PGconn *pg_conn;

void
requrl(struct client_info slave_socket, struct input client_input){
  PGresult *result;
  char *pgexec;

  /* Open a connection to the database */
  pg_conn = PQsetdb("localhost", NULL, NULL, NULL, "teaserdb");
  /* check it opened OK */
  if(PQstatus(pg_conn) == CONNECTION_BAD){
	t_error(PQerrorMessage(pg_conn), TRUE);
  }


  /* get the user's email */
  pgexec = malloc((strlen("SELECT Url.value[2][1] FROM Url WHERE tfa = '") +
		   strlen(client_input.req_tfa) +
		   strlen("';")+1) * sizeof(char));
  strcpy(pgexec, "SELECT Url.value[2][1] FROM Url WHERE tfa = '");
  strcat(pgexec, client_input.req_tfa);
  strcat(pgexec, "';");

  t_error(pgexec, FALSE);
  result = db_exec(pg_conn, pgexec);

  if(result == NULL){
    tfp_error(slave_socket.socket, 402);
    t_error(PQerrorMessage(pg_conn), FALSE);
    free(pgexec);
    PQfinish(pg_conn);
    return;
  }

  if(PQresultStatus(result) == PGRES_TUPLES_OK && PQntuples(result) == 1){

    free(pgexec);
    pgexec = PQgetvalue(result, 0, 0);

    write(slave_socket.socket, pgexec, strlen(pgexec));
    write(slave_socket.socket, "\n", strlen("\n"));
  }else{
    tfp_error(slave_socket.socket, 201);
    t_error(PQerrorMessage(pg_conn), FALSE);
    
    free(pgexec);
    PQfinish(pg_conn);
    return;
  }

  
  free(pgexec);
  PQfinish(pg_conn);
}
